\chapter{Introduction}

History often gives us valuable lessons of how things might end up. For example,
one of the very first cryptographers, Gaius Julius Caesar, was attacked by his
peers and stabbed to death. Alan Mathison Turing, a~successful cryptanalyst of
the Enigma cipher, died of cyanide poisoning caused by his own hand. The study
of cryptography and cryptanalysis is up to us now.

We will begin our work by discussing the elementary algebraic structures and
gradually progress towards Gröbner bases. We will then show how Gröbner bases
can be used to solve systems of multivariate polynomial equations.

In the second chapter, we will describe AES, its small scale variants, and
we will discuss some algebraic properties of this cipher. We will then derive
polynomial systems over GF(2) for the small scale versions of AES. As we
will show, a~solution to a polynomial system describing the cipher will in fact
represent the secret key for the cipher. We will see that besides solving
polynomial systems, Gröbner bases are also useful for modeling the cipher so
that the resulting equations contain only the variables of the initial secret
key.

Given that we are leveraging the algebraic properties of the cipher to obtain
its algebraic model, which is a system of equations, and that we are using
algebraic techniques to solve these systems, we are referring to this form of
analyzing the cipher as algebraic cryptanalysis.

The last chapter discusses the results of our experiments. We will demonstrate
the current capabilities of Gröbner bases in solving the polynomial systems from
the second chapter, and we will compare their performance to a SAT solver. We
will also present some techniques for reducing the polynomial systems before
solving them, and we will discuss the progress of diffusion within the reduced
versions of AES.
